# Change Log
## Future
* (helloGPU) Fixed bug that occasionally occurred when reloading shaders.
* (helloGPU) Fixed bug preventing file dialogs from opening when an invalid default path was specified.
* (helloShader) Fixed bug when looking up shader constant historical values that have a different array size than the current shader constant.

## 4/24/2019
* (helloTexture) About dialog
* (helloShader) Controls dialog
* (helloShader) Fixed bug when saving shader or texture paths that were on different drives than the workspace.
* (helloShader) About dialog
* (helloShader) Shader parameters with a set min, max range have an improved input widget.
* (helloShader) Fixed available variables text to use float3x4 instead of float4x3.
* (helloShader) Fixed crash when trying to open the 'System->GPU Info' menu item.
* (helloShader) Fixed dynamic shader reloading in dx11.
* (helloShader) Fixed bug with file browser input display paths.
* (helloShader) Added basic shader stage input/output parameter verification to dx11 shader compilation.
* (helloGPU) Recreating shaders is now thread safe.
* (helloGPU) Fixed dx11 sampler states. They were not correctly storing their parameters.
* (helloGPU) Profile groups and gpu object debug names are now available in all builds.
* (helloGPU) Fixed uploading of float2x2, float2x3, float3x2, float3x3, float4x2, float4x3 matrices, as well as the double variants.

## 03/11/2019
* (helloShader) Fixed a bug when trying to find the next available scene object id when loading a workspace.
* (helloShader) Fixed input layout for the default shader
* (helloShader) Fixed issue with constant buffers not updating
* (helloShader) Improved iconography
* (helloShader) Added acknowledgements and credits to helloShader
* (helloGPU) Basic high dpi support.
* (helloGPU) Added license.

## 02/05/2019
* (helloShader) Generated shaders have more descriptive names
* (helloShader) Added button next to shader file input to open the file
* (helloShader) New projects will generate hello world shaders and assign them to the already created scene object
* (helloShader) Available global shader constants list has some description of what they are
* (helloShader) Orbiting camera orbits around the selected scene object
* (helloShader) New hotkey 'F' will focus on the selected scene object
* (helloShader) Creating a new workspace through the menu bar 'File'->'New Workspace' or from the keyboard shortcut will prompt with a save dialog
* (helloShader) Most recently opened workspace is remembered and will open when the helloShader
* (helloGPU) Application settings are saved to %USERPROFILE%/AppData/Local/helloGpu